﻿Imports SolidWorks.Interop.swdocumentmgr

Public Class frmMain

    Public oSwDocMgrClassFacCls As SwDMClassFactory
    Public oSwDocMgrCls As SwDMApplication
    Public swDMLicenseKey As String

    Private Sub bt_addFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_addFiles.Click
        Dim filelist As String()

        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Try
                filelist = OpenFileDialog1.FileNames
                If (filelist IsNot Nothing) Then
                    lbxFiles.Items.AddRange(filelist)
                End If
            Catch Ex As Exception

            End Try
        End If
    End Sub

    Private Sub bt_close_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_close.Click
        End
    End Sub

    Private Sub bt_addFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_addFolder.Click

        Dim SearchOption As IO.SearchOption = IO.SearchOption.TopDirectoryOnly
        If cb_subDirs.Checked Then SearchOption = IO.SearchOption.AllDirectories

        If FolderBrowserDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim myPath As String = FolderBrowserDialog1.SelectedPath

            Dim files As IEnumerable(Of String) = From file In IO.Directory.EnumerateFiles(myPath, "*.sldprt", SearchOption).Union(IO.Directory.EnumerateFiles(myPath, ".prt", SearchOption)) Where Not file.Contains("~$")

            If (files IsNot Nothing) Then
                lbxFiles.Items.AddRange(files.ToArray)
            End If
        End If

    End Sub

    Private Sub bt_remove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_remove.Click

        Dim index As Integer = lbxFiles.SelectedIndex
        For i As Integer = 1 To lbxFiles.SelectedItems.Count
            lbxFiles.Items.Remove(lbxFiles.SelectedItems(0))
        Next

        If lbxFiles.Items.Count <= index Then index = lbxFiles.Items.Count - 1
        lbxFiles.SelectedIndex = index

    End Sub

    Private Sub bt_clear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_clear.Click
        lbxFiles.Items.Clear()
    End Sub

    Private Sub bt_update_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_update.Click
        frmProgress.ShowDialog()
    End Sub

    Private Sub bt_show_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_show.Click

        Dim swDoc As SwDMDocument18
        Dim nDocType As SwDmDocumentType = SwDmDocumentType.swDmDocumentPart
        Dim nRetVal As SwDmDocumentOpenError

        Dim sText As New Collections.Specialized.StringCollection

        For Each SelectedItem As String In lbxFiles.SelectedItems
            swDoc = CType(oSwDocMgrCls.GetDocument(SelectedItem, nDocType, False, nRetVal), SwDMDocument18)
            Try
                sText.Add("Datei(" & SelectedItem & ") Eigenschaft (IsFastener) = (" & swDoc.GetCustomProperty("IsFastener", SwDmCustomInfoType.swDmCustomInfoYesOrNo) & ")")
            Catch ex As Exception
                sText.Add("Keine Dokumenteigenschaft (IsFastener) in Datei (" & SelectedItem & ") erhalten")
            Finally
                swDoc.CloseDoc()
            End Try
        Next

        MessageBox.Show(String.Join(Environment.NewLine, sText.Cast(Of String)().ToArray), Me.Text)

    End Sub

End Class
